export declare class _PdfColorPalette {
    name: string;
    numComps: number;
    base: any;
    bytes: any;
    constructor(name: string, numComps: number);
    _resizeRgbImage(src: Uint8Array, dest: Uint8Array, w1: number, h1: number, w2: number, h2: number, alpha01: number): void;
    _isDefaultDecode(decode: any, numComps: number): boolean;
    _getRgb(src: Uint8Array, srcOffset: number): Uint8ClampedArray;
    _getRgbItem(src: any, srcOffset: number, dest: any, destOffset: number): void;
    _getRgbBuffer(src: any, srcOffset: number, count: number, dest: any, destOffset: number, bits: number, // eslint-disable-line
    alpha01: number): any;
    _getOutputLength(inputLength: number, alpha01: number): void;
    _isPass(bits: any): boolean;
    _fillRgb(dest: any, originalWidth: number, originalHeight: number, width: number, height: number, // eslint-disable-line
    actualHeight: number, bpc: number, comps: Uint8Array | Uint16Array, alpha01: number): Promise<any>;
}
export declare class _PdfAlternateCS extends _PdfColorPalette {
    base: _PdfColorPalette;
    private tmpBuf;
    constructor(numComps: number, base: _PdfColorPalette);
    _getRgbItem(src: Uint8Array, srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: Uint8Array, srcOffset: number, count: number, dest: Uint8Array, destOffset: number, bits: number, alpha01: number): void;
}
export declare class _PdfPatternCS extends _PdfColorPalette {
    base: any;
    constructor(baseCS: any);
    _isDefaultDecode(decodeMap: any, bpc: any): boolean;
}
export declare class _PdfIndexedCS extends _PdfColorPalette {
    base: any;
    private highVal;
    private lookup;
    constructor(base: any, highVal: number, lookup: any);
    _getRgbItem(src: any, srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: any, srcOffset: number, count: number, dest: Uint8ClampedArray, destOffset: number, // eslint-disable-line
    bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
    _isDefaultDecode(decodeMap: any[], bpc: number): boolean;
}
export declare class _PdfDeviceGrayCS extends _PdfColorPalette {
    constructor();
    _getRgbItem(src: any, srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: any, srcOffset: number, count: number, dest: Uint8ClampedArray, destOffset: number, // eslint-disable-line
    bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
}
export declare class _PdfDeviceRgbCS extends _PdfColorPalette {
    constructor();
    _getRgbItem(src: any, srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: any, srcOffset: number, count: number, dest: Uint8ClampedArray, destOffset: number, // eslint-disable-line
    bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
    _isPass(bits: number): boolean;
}
export declare class _PdfDeviceRgbaCS extends _PdfColorPalette {
    constructor();
    _resizeRgbaImage(src: Uint8Array, dest: Uint8Array, w1: number, h1: number, w2: number, h2: number, alpha01: number): void;
    _copyRgbaImage(src: Uint8Array, dest: Uint8Array, alpha01: number): void;
    _getOutputLength(inputLength: number, _alpha01: number): number;
    _isPass(bits: number): boolean;
    _fillRgb(dest: any, originalWidth: number, originalHeight: number, width: number, height: number, // eslint-disable-line
    actualHeight: number, bpc: number, comps: any, alpha01: number): Promise<any>;
}
export declare class _PdfDeviceCmykCS extends _PdfColorPalette {
    constructor();
    _toRgb(src: any, srcOffset: number, srcScale: number, dest: any, destOffset: number): void;
    _getRgbItem(src: any, srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: any, srcOffset: number, count: number, dest: Uint8ClampedArray, destOffset: number, // eslint-disable-line
    bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
}
export declare class _PdfLabCS extends _PdfColorPalette {
    private _xw;
    private _yw;
    private _zw;
    private _xb;
    private _yb;
    private _zb;
    private _amin;
    private _amax;
    private _bmin;
    private _bmax;
    constructor(whitePoint?: number[], blackPoint?: number[], range?: number[]);
    private _fng;
    private _decode;
    private _toRgb;
    _getRgbItem(src: Uint8Array, srcOffset: number, dest: any, destOffset: number): void;
    _getRgbBuffer(src: Uint8Array, srcOffset: number, count: number, dest: any, destOffset: number, // eslint-disable-line
    bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
    _isDefaultDecode(decodeMap: any, bpc: number): boolean;
    readonly usesZeroToOneRange: boolean;
}
export declare class _PdfCalGrayCS extends _PdfColorPalette {
    _xw: number;
    _yw: number;
    _zw: number;
    _xb: number;
    _yb: number;
    _zb: number;
    _g: number;
    constructor(whitePoint: number[], blackPoint?: number[], gamma?: number);
    _toRgb(src: number[], srcOffset: number, dest: number[], destOffset: number, scale: number): void;
    _getRgbItem(src: number[], srcOffset: number, dest: any, destOffset: number): void;
    _getRgbBuffer(src: number[], srcOffset: number, count: number, dest: any, destOffset: number, bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
}
export declare class _PdfColorRgbConverter extends _PdfColorPalette {
    scaleMatrix: Float32Array;
    inverseMatrix: Float32Array;
    rgbMatrix: Float32Array;
    whitePointMatrix: Float32Array;
    tempNormalizeMatrix: Float32Array;
    tempConvertMatrix1: Float32Array;
    tempConvertMatrix2: Float32Array;
    decodeConstant: number;
    _whitePoint: Float32Array;
    _blackPoint: Float32Array;
    gr: number;
    gg: number;
    gb: number;
    mxa: number;
    mya: number;
    mza: number;
    mxb: number;
    myb: number;
    mzb: number;
    mxc: number;
    myc: number;
    mzc: number;
    constructor(whitePoint: any, blackPoint?: any, gamma?: any, matrix?: any);
    _matrixProduct(a: Float32Array, b: Float32Array, result: Float32Array): void;
    _toFlat(sourceWhitePoint: Float32Array, lms: Float32Array, result: Float32Array): void;
    _toD65(sourceWhitePoint: Float32Array, lms: Float32Array, result: Float32Array): void;
    _srgbTransferFunction(color: number): number;
    _decodeL(L: number): number;
    _compensateBlackPoint(sourceBlackPoint: Float32Array, xyzFlat: Float32Array, result: Float32Array): void;
    _normalizeWhitePointToFlat(sourceWhitePoint: Float32Array, xyzIn: Float32Array, result: Float32Array): void;
    _normalizeWhitePointToD65(sourceWhitePoint: Float32Array, xyzIn: Float32Array, result: Float32Array): void;
    _toRgb(src: number[], srcOffset: number, dest: Uint8ClampedArray, destOffset: number, scale: number): void;
    _getRgbItem(src: number[], srcOffset: number, dest: Uint8ClampedArray, destOffset: number): void;
    _getRgbBuffer(src: number[], srcOffset: number, count: number, dest: Uint8ClampedArray, destOffset: number, bits: number, alpha01: number): void;
    _getOutputLength(inputLength: number, alpha01: number): number;
}
